## mingw-w64-aws-crt-cpp-0.26.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()

option(BUILD_DEPS "Builds aws common runtime dependencies as part of build. Turn off if you want to control your dependency chain." ON)
option(BYO_CRYPTO "Don't build a tls implementation or link against a crypto interface. This feature is only for unix builds currently" OFF)
option(USE_OPENSSL "Set this if you want to use your system's OpenSSL 1.0.2/1.1.1 compatible libcrypto" OFF)

# Let aws-iot-device-sdk-cpp-v2 report its own version in MQTT connections (instead of reporting aws-crt-cpp's version).
option(AWS_IOT_SDK_VERSION "Set the version reported by Aws::Iot::MqttClientConnectionConfigBuilder")

# Tests require environment variables setup in order to run properly.
# See https://github.com/awslabs/aws-crt-builder/blob/main/builder/actions/setup_cross_ci_crt_environment.py
# for how environment variables are setup.
# NOTE: Some environment variables use Mosquitto or Proxy servers, which are assumed to be installed
# locally if running the testing outside of CI/CD.
option(ENABLE_PROXY_INTEGRATION_TESTS "Whether or not to build and run the proxy integration tests that rely on a proxy server installed and running locally" OFF)


list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(AwsGetVersion)
aws_get_version(SIMPLE_VERSION FULL_VERSION GIT_HASH)
message(STATUS "AWS CRT C++ ${FULL_VERSION}")

project("aws-crt-cpp"
    LANGUAGES CXX C
    VERSION ${SIMPLE_VERSION})

include(CTest)

if(DEFINED CMAKE_PREFIX_PATH)
    file(TO_CMAKE_PATH "${CMAKE_PREFIX_PATH}" CMAKE_PREFIX_PATH)
endif()

if(DEFINED CMAKE_INSTALL_PREFIX)
    file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" CMAKE_INSTALL_PREFIX)
endif()

if(UNIX AND NOT APPLE)
    include(GNUInstallDirs)
elseif(NOT DEFINED CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR "lib")
endif()

if(${CMAKE_INSTALL_LIBDIR} STREQUAL "lib64")
    set(FIND_LIBRARY_USE_LIB64_PATHS true)
endif()

if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
endif()

if(NOT CMAKE_BUILD_TYPE)
    # setting this breaks C++ builds in visualc++, so don't do it.
    if(NOT WIN32)
        set(CMAKE_BUILD_TYPE "RelWithDebInfo")
    endif()
endif()

set(GENERATED_ROOT_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(GENERATED_INCLUDE_DIR "${GENERATED_ROOT_DIR}/include")
set(GENERATED_CONFIG_HEADER "${GENERATED_INCLUDE_DIR}/aws/crt/Config.h")
configure_file(include/aws/crt/Config.h.in ${GENERATED_CONFIG_HEADER} @ONLY)

# This is required in order to append /lib/cmake to each element in CMAKE_PREFIX_PATH
set(AWS_MODULE_DIR "/${CMAKE_INSTALL_LIBDIR}/cmake")
string(REPLACE ";" "${AWS_MODULE_DIR};" AWS_MODULE_PATH "${CMAKE_PREFIX_PATH}${AWS_MODULE_DIR}")

# Append that generated list to the module search path
list(APPEND CMAKE_MODULE_PATH ${AWS_MODULE_PATH})

if(BUILD_DEPS)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/crt/aws-c-common/cmake")

    include(AwsFindPackage)

    set(IN_SOURCE_BUILD ON)
    set(BUILD_TESTING_PREV ${BUILD_TESTING})
    set(BUILD_TESTING OFF)
    add_subdirectory(crt/aws-c-common)

    if(UNIX AND NOT APPLE AND NOT BYO_CRYPTO)
        if(NOT USE_OPENSSL)
            set(DISABLE_PERL ON CACHE BOOL "Disable Perl for AWS-LC.")
            set(DISABLE_GO ON CACHE BOOL "Disable Go for AWS-LC.")
            set(BUILD_LIBSSL OFF CACHE BOOL "Build libssl for AWS-LC.")

            # temporarily disable certain warnings as errors for the aws-lc build
            set(OLD_CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")

            if(NOT MSVC)
                check_c_compiler_flag(-Wno-stringop-overflow HAS_WNO_STRINGOP_OVERFLOW)

                if(HAS_WNO_STRINGOP_OVERFLOW)
                    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-stringop-overflow")
                endif()

                check_c_compiler_flag(-Wno-array-parameter HAS_WNO_ARRAY_PARAMETER)

                if(HAS_WNO_ARRAY_PARAMETER)
                    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-array-parameter")
                endif()
            endif()

            add_subdirectory(crt/aws-lc)

            # restore previous build flags
            set(CMAKE_C_FLAGS "${OLD_CMAKE_C_FLAGS}")

            set(SEARCH_LIBCRYPTO OFF CACHE BOOL "Let S2N use libcrypto from AWS-LC.")
        else()
            set(SEARCH_LIBCRYPTO ON CACHE BOOL "Let S2N search libcrypto in the system.")
        endif()

        set(UNSAFE_TREAT_WARNINGS_AS_ERRORS OFF CACHE BOOL "Disable warnings-as-errors when building S2N")
        add_subdirectory(crt/s2n)
    endif()

    add_subdirectory(crt/aws-c-sdkutils)
    add_subdirectory(crt/aws-c-io)
    add_subdirectory(crt/aws-c-cal)
    add_subdirectory(crt/aws-c-compression)
    add_subdirectory(crt/aws-c-http)
    add_subdirectory(crt/aws-c-auth)
    add_subdirectory(crt/aws-c-mqtt)
    add_subdirectory(crt/aws-checksums)
    add_subdirectory(crt/aws-c-event-stream)
    add_subdirectory(crt/aws-c-s3)
    set(BUILD_TESTING ${BUILD_TESTING_PREV})
else()
    include(AwsFindPackage)
    set(IN_SOURCE_BUILD OFF)
endif()

include(AwsCFlags)
include(AwsSharedLibSetup)

file(GLOB AWS_CRT_HEADERS
    "include/aws/crt/*.h"
    ${GENERATED_CONFIG_HEADER}
)

file(GLOB AWS_CRT_AUTH_HEADERS
    "include/aws/crt/auth/*.h"
)

file(GLOB AWS_CRT_CRYPTO_HEADERS
    "include/aws/crt/crypto/*.h"
)

file(GLOB AWS_CRT_IO_HEADERS
    "include/aws/crt/io/*.h"
)

file(GLOB AWS_CRT_IOT_HEADERS
    "include/aws/iot/*.h"
)

file(GLOB AWS_CRT_MQTT_HEADERS
    "include/aws/crt/mqtt/*.h"
)

file(GLOB AWS_CRT_HTTP_HEADERS
    "include/aws/crt/http/*.h"
)

file(GLOB AWS_CRT_ENDPOINT_HEADERS
    "include/aws/crt/endpoints/*.h"
)

file(GLOB AWS_CRT_EXTERNAL_HEADERS
    "include/aws/crt/external/*.h"
)

file(GLOB AWS_CRT_PUBLIC_HEADERS
    ${AWS_CRT_HEADERS}
    ${AWS_CRT_AUTH_HEADERS}
    ${AWS_CRT_CRYPTO_HEADERS}
    ${AWS_CRT_IO_HEADERS}
    ${AWS_CRT_IOT_HEADERS}
    ${AWS_CRT_MQTT_HEADERS}
    ${AWS_CRT_HTTP_HEADERS}
    ${AWS_CRT_ENDPOINT_HEADERS}
)

if(BUILD_DEPS)
    include(AwsCheckHeaders)
    aws_check_headers(${PROJECT_NAME} IS_CXX ${AWS_CRT_PUBLIC_HEADERS})
endif()

file(GLOB AWS_CRT_CPP_HEADERS
    ${AWS_CRT_PUBLIC_HEADERS}
    ${AWS_CRT_EXTERNAL_HEADERS}
)

file(GLOB AWS_CRT_SRC
    "source/*.cpp"
)

file(GLOB AWS_CRT_AUTH_SRC
    "source/auth/*.cpp"
)

file(GLOB AWS_CRT_CRYPTO_SRC
    "source/crypto/*.cpp"
)

file(GLOB AWS_CRT_IO_SRC
    "source/io/*.cpp"
)

file(GLOB AWS_CRT_IOT_SRC
    "source/iot/*.cpp"
)

file(GLOB AWS_CRT_MQTT_SRC
    "source/mqtt/*.cpp"
)

file(GLOB AWS_CRT_HTTP_SRC
    "source/http/*.cpp"
)

file(GLOB AWS_CRT_ENDPOINTS_SRC
    "source/endpoints/*.cpp"
)

file(GLOB AWS_CRT_EXTERNAL_SRC
    "source/external/*.cpp"
)

file(GLOB AWS_CRT_CPP_SRC
    ${AWS_CRT_SRC}
    ${AWS_CRT_AUTH_SRC}
    ${AWS_CRT_CRYPTO_SRC}
    ${AWS_CRT_IO_SRC}
    ${AWS_CRT_IOT_SRC}
    ${AWS_CRT_MQTT_SRC}
    ${AWS_CRT_HTTP_SRC}
    ${AWS_CRT_ENDPOINTS_SRC}
    ${AWS_CRT_EXTERNAL_SRC}
)

if(WIN32)
    if(MSVC)
        source_group("Header Files\\aws\\crt" FILES ${AWS_CRT_HEADERS})
        source_group("Header Files\\aws\\crt\\auth" FILES ${AWS_CRT_AUTH_HEADERS})
        source_group("Header Files\\aws\\crt\\crypto" FILES ${AWS_CRT_CRYPTO_HEADERS})
        source_group("Header Files\\aws\\crt\\io" FILES ${AWS_CRT_IO_HEADERS})
        source_group("Header Files\\aws\\iot" FILES ${AWS_CRT_IOT_HEADERS})
        source_group("Header Files\\aws\\crt\\mqtt" FILES ${AWS_CRT_MQTT_HEADERS})
        source_group("Header Files\\aws\\crt\\http" FILES ${AWS_CRT_HTTP_HEADERS})
        source_group("Header Files\\aws\\crt\\endpoints" FILES ${AWS_CRT_ENDPOINT_HEADERS})

        source_group("Source Files" FILES ${AWS_CRT_SRC})
        source_group("Source Files\\auth" FILES ${AWS_CRT_AUTH_SRC})
        source_group("Source Files\\crypto" FILES ${AWS_CRT_CRYPTO_SRC})
        source_group("Source Files\\io" FILES ${AWS_CRT_IO_SRC})
        source_group("Source Files\\iot" FILES ${AWS_CRT_IOT_SRC})
        source_group("Source Files\\mqtt" FILES ${AWS_CRT_MQTT_SRC})
        source_group("Source Files\\http" FILES ${AWS_CRT_HTTP_SRC})
        source_group("Source Files\\endpoints" FILES ${AWS_CRT_ENDPOINTS_SRC})
    endif()
endif()

add_library(${PROJECT_NAME} ${AWS_CRT_CPP_HEADERS} ${AWS_CRT_CPP_SRC})

target_compile_definitions(${PROJECT_NAME} PRIVATE -DCJSON_HIDE_SYMBOLS)

if(AWS_IOT_SDK_VERSION)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "-DAWS_IOT_SDK_VERSION=\"${AWS_IOT_SDK_VERSION}\"")
endif()

if(BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PUBLIC -DAWS_CRT_CPP_USE_IMPORT_EXPORT)
    target_compile_definitions(${PROJECT_NAME} PRIVATE -DAWS_CRT_CPP_EXPORTS)
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES LINKER_LANGUAGE CXX)
set_target_properties(${PROJECT_NAME} PROPERTIES CXX_STANDARD ${CMAKE_CXX_STANDARD})

aws_prepare_symbol_visibility_args(${PROJECT_NAME} "AWS_CRT_CPP")

# set runtime library
if(MSVC)
    if(AWS_STATIC_MSVC_RUNTIME_LIBRARY OR STATIC_CRT)
        target_compile_options(${PROJECT_NAME} PRIVATE "/MT$<$<CONFIG:Debug>:d>")
    else()
        target_compile_options(${PROJECT_NAME} PRIVATE "/MD$<$<CONFIG:Debug>:d>")
    endif()
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE $<$<CONFIG:Debug>:DEBUG_BUILD>)

# set extra warning flags
if(AWS_WARNINGS_ARE_ERRORS)
    if(MSVC)
        target_compile_options(${PROJECT_NAME} PRIVATE /W4 /WX /wd4068)
    else()
        target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Wno-long-long -pedantic -Werror)
    endif()
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${GENERATED_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include>)

aws_use_package(aws-c-http)
aws_use_package(aws-c-mqtt)
aws_use_package(aws-c-cal)
aws_use_package(aws-c-auth)
aws_use_package(aws-c-common)
aws_use_package(aws-c-io)
aws_use_package(aws-checksums)
aws_use_package(aws-c-event-stream)
aws_use_package(aws-c-s3)

include(AwsSanitizers)
aws_add_sanitizers(${PROJECT_NAME})

target_link_libraries(${PROJECT_NAME} PUBLIC ${DEP_AWS_LIBS})

install(FILES ${AWS_CRT_HEADERS} DESTINATION "include/aws/crt" COMPONENT Development)
install(FILES ${AWS_CRT_AUTH_HEADERS} DESTINATION "include/aws/crt/auth" COMPONENT Development)
install(FILES ${AWS_CRT_CRYPTO_HEADERS} DESTINATION "include/aws/crt/crypto" COMPONENT Development)
install(FILES ${AWS_CRT_IO_HEADERS} DESTINATION "include/aws/crt/io" COMPONENT Development)
install(FILES ${AWS_CRT_IOT_HEADERS} DESTINATION "include/aws/iot" COMPONENT Development)
install(FILES ${AWS_CRT_MQTT_HEADERS} DESTINATION "include/aws/crt/mqtt" COMPONENT Development)
install(FILES ${AWS_CRT_HTTP_HEADERS} DESTINATION "include/aws/crt/http" COMPONENT Development)
install(FILES ${AWS_CRT_ENDPOINT_HEADERS} DESTINATION "include/aws/crt/endpoints" COMPONENT Development)

install(
    TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}-targets
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
    RUNTIME DESTINATION bin COMPONENT Runtime
)

if(BUILD_SHARED_LIBS)
    set(TARGET_DIR "shared")
else()
    set(TARGET_DIR "static")
endif()

install(EXPORT "${PROJECT_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/cmake/${TARGET_DIR}"
    NAMESPACE AWS::
    COMPONENT Development)

configure_file("cmake/${PROJECT_NAME}-config.cmake"
    "${GENERATED_ROOT_DIR}/${PROJECT_NAME}-config.cmake"
    @ONLY)

include(CMakePackageConfigHelpers)

write_basic_package_version_file(
    "${GENERATED_ROOT_DIR}/${PROJECT_NAME}-config-version.cmake"
    COMPATIBILITY ExactVersion
)

install(FILES "${GENERATED_ROOT_DIR}/${PROJECT_NAME}-config.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/cmake/"
    COMPONENT Development)

install(FILES "${GENERATED_ROOT_DIR}/${PROJECT_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}/cmake/"

=== tests/CMakeLists.txt ===
include(AwsTestHarness)
enable_testing()
include(CTest)

file(GLOB TEST_SRC "*.cpp")
file(GLOB TEST_HDRS "*.h")
file(GLOB TESTS ${TEST_HDRS} ${TEST_SRC})

set(TEST_BINARY_NAME ${PROJECT_NAME}-tests)

add_test_case(ApiMultiCreateDestroy)
add_test_case(ApiMultiDefaultCreateDestroy)
add_test_case(ApiStaticDefaultCreateDestroy)
add_test_case(EventLoopResourceSafety)
add_test_case(ClientBootstrapResourceSafety)

if(NOT BYO_CRYPTO)
    add_net_test_case(MqttClientResourceSafety)
    add_net_test_case(MqttClientNewConnectionUninitializedTlsContext)
    add_net_test_case(TLSContextResourceSafety)
    add_net_test_case(TLSContextUninitializedNewConnectionOptions)
    add_test_case(Sigv4aSigningTestCredentials)

    add_net_test_case(IoTMqtt311ConnectWithNoSigningCustomAuth)
    add_net_test_case(IoTMqtt311ConnectWithSigningCustomAuth)
    add_net_test_case(IoTMqtt311ConnectWithSigningCustomAuthUnencoded)
    add_net_test_case(IoTMqtt311ConnectWithSigningCustomAuthWebsockets)
    add_net_test_case(IoTMqtt311ConnectWithSigningCustomAuthWebsocketsUnencoded)
    add_net_test_case(IoTMqtt311ConnectWithPKCS11)
    add_net_test_case(IoTMqtt311ConnectWithPKCS12)
    add_net_test_case(IoTMqtt311ConnectWithWindowsCert)
    add_net_test_case(IoTMqtt311ConnectWSDefault)
    add_net_test_case(IoTMqtt311ConnectWSStatic)
    add_net_test_case(IoTMqtt311ConnectWSCognito)
    add_net_test_case(IoTMqtt311ConnectWSProfile)
    add_net_test_case(IoTMqtt311ConnectWSEnvironment)

    add_net_test_case(IoTMqtt5ConnectWithmTLS)
    add_net_test_case(IoTMqtt5ConnectWithWebsocket)
    add_net_test_case(IoTMqtt5ConnectWithSigningCustomAuth)
    add_net_test_case(IoTMqtt5ConnectWithSigningCustomAuthUnencoded)
    add_net_test_case(IoTMqtt5ConnectWithNoSigningCustomAuth)
    add_net_test_case(IoTMqtt5ConnectWithNoSigningCustomAuthWebsockets)
    add_net_test_case(IoTMqtt5ConnectWithSigningCustomAuthWebsockets)
    add_net_test_case(IoTMqtt5ConnectWithSigningCustomAuthWebsocketsUnencoded)
    add_net_test_case(IoTMqtt5ConnectWithPKCS11)
    add_net_test_case(IoTMqtt5ConnectWithPKCS12)
    add_net_test_case(IoTMqtt5ConnectWithWindowsCert)
    add_net_test_case(IoTMqtt5ConnectWSStatic)
    add_net_test_case(IoTMqtt5ConnectWSCognito)
    add_net_test_case(IoTMqtt5ConnectWSProfile)
    add_net_test_case(IoTMqtt5ConnectWSEnvironment)
    add_net_test_case(IoTMqtt5ConnectWSX509)

endif()

add_test_case(Base64RoundTrip)
add_test_case(DateTimeBinding)
add_test_case(BasicJsonParsing)
add_test_case(JsonNullParsing)
add_test_case(JsonNullNestedObject)
add_test_case(JsonExplicitNull)
add_test_case(JsonBoolTest)
add_test_case(JsonMoveTest)
add_test_case(SHA256ResourceSafety)
add_test_case(MD5ResourceSafety)
add_test_case(SHA256HMACResourceSafety)

if(NOT BYO_CRYPTO)
    add_net_test_case(HttpDownloadNoBackPressureHTTP1_1)
    add_net_test_case(HttpDownloadNoBackPressureHTTP2)
    add_net_test_case(HttpStreamUnActivated)
    add_net_test_case(HttpCreateConnectionInvalidTlsConnectionOptions)
    add_net_test_case(IotPublishSubscribe)
    add_net_test_case(IotConnectionSuccessTest)
    add_net_test_case(IotConnectionFailureTest)
    add_net_test_case(IotWillTest)
    add_net_test_case(IoTStatisticsPublishWaitStatisticsDisconnect)
    add_net_test_case(IoTStatisticsPublishStatisticsWaitDisconnect)
    add_net_test_case(HttpClientConnectionManagerResourceSafety)
    add_net_test_case(HttpClientConnectionManagerInvalidTlsConnectionOptions)
    add_net_test_case(HttpClientConnectionWithPendingAcquisitions)
    add_net_test_case(HttpClientConnectionWithPendingAcquisitionsAndClosedConnections)
    add_net_test_case(IotConnectionDestruction)
    add_net_test_case(IotConnectionDestructionWithExecutingCallback)
    add_net_test_case(IotConnectionDestructionWithinConnectionCallback)
    add_net_test_case(IotConnectionDestructionWithinDisconnectCallback)
    add_net_test_case(IotConnectionDestructionWithPublish)
endif()

add_test_case(DefaultResolution)
add_test_case(OptionalCopySafety)
add_test_case(OptionalMoveSafety)
add_test_case(OptionalCopyAndMoveSemantics)
add_test_case(StreamTestCreateDestroyWrapper)
add_test_case(StreamTestLength)
add_test_case(StreamTestRead)
add_test_case(StreamTestReadEmpty)
add_test_case(StreamTestSeekBegin)
add_test_case(StreamTestSeekEnd)
add_test_case(StreamTestRefcount)
add_test_case(TestCredentialsConstruction)
add_test_case(TestAnonymousCredentialsConstruction)
add_test_case(TestProviderStaticGet)
add_test_case(TestProviderAnonymousGet)
add_test_case(TestProviderEnvironmentGet)
add_test_case(TestProviderProfileGet)
add_test_case(TestProviderImdsGet)

if(NOT BYO_CRYPTO)
    add_net_test_case(TestProviderDefaultChainGet)
    add_net_test_case(TestProviderDefaultChainManualTlsContextGet)
endif()

add_test_case(TestProviderDelegateGet)
add_test_case(TestProviderDelegateGetAnonymous)
add_test_case(HttpRequestTestCreateDestroy)
add_test_case(Sigv4SigningTestCreateDestroy)

if(NOT BYO_CRYPTO)
    add_test_case(Sigv4SigningTestSimple)
    add_test_case(Sigv4SigningTestCredentials)
    add_test_case(Sigv4SigningTestUnsignedPayload)
endif()

add_test_case(UUIDToString)
add_test_case(TestIntArrayListToVector)
add_test_case(TestByteCursorArrayListToVector)
add_test_case(StringViewTest)
add_test_case(TestCreatingImdsClient)
add_test_case(ChannelHandlerInterop)

if(AWS_BUILDING_ON_EC2)
    add_test_case(TestImdsClientGetInstanceInfo)
    add_test_case(TestImdsClientGetCredentials)
endif()

if(ENABLE_PROXY_INTEGRATION_TESTS AND NOT BYO_CRYPTO)
    # connection manager proxy tests
    add_test_case(ConnectionManagerTunnelingProxyHttp)
    add_test_case(ConnectionManagerTunnelingProxyHttps)
    add_test_case(ConnectionManagerTunnelingProxyHttpsInvalidTlsOptions)
    add_test_case(ConnectionManagerForwardingProxy)
    add_test_case(ConnectionManagerTunnelingProxyBasicAuthDeprecated)
    add_test_case(ConnectionManagerTunnelingProxyBasicAuth)

    # direction connection proxy tests
    add_test_case(DirectConnectionTunnelingProxyHttp)
    add_test_case(DirectConnectionTunnelingProxyHttps)
    add_test_case(DirectConnectionTunnelingProxyHttpsInvalidTlsOptions)
    add_test_case(DirectConnectionForwardingProxy)
    add_test_case(DirectConnectionTunnelingProxyBasicAuthDeprecated)
    add_test_case(DirectConnectionTunnelingProxyBasicAuth)

    # x509 provider proxy tests
    add_test_case(X509ProxyHttpGetCredentials)
    add_test_case(X509ProxyHttpsGetCredentials)
    add_test_case(X509ProxyBasicAuthDeprecatedGetCredentials)
    add_test_case(X509ProxyBasicAuthGetCredentials)

    # mqtt-over-websockets proxy tests using x509 credentials
    add_test_case(MqttOverWebsocketsViaHttpProxy)
    add_test_case(MqttOverWebsocketsViaHttpsProxy)
    add_test_case(MqttOverWebsocketsViaHttpProxyBasicAuthDeprecated)
    add_test_case(MqttOverWebsocketsViaHttpProxyBasicAuth)

    # mqtt-via-alpn proxy tests
    add_test_case(MqttViaHttpProxyAlpn)
    add_test_case(MqttViaHttpsProxyAlpn)
    add_test_case(MqttViaHttpProxyAlpnBasicAuthDeprecated)
    add_test_case(MqttViaHttpProxyAlpnBasicAuth)
endif()

#MQTT311 related tests
if (NOT BYO_CRYPTO)
    # MQTT311 TESTS
    add_net_test_case(Mqtt311DirectConnectionMinimal)
    add_net_test_case(Mqtt311DirectConnectionWithBasicAuth)
    add_net_test_case(Mqtt311DirectConnectionWithTLS)
    add_net_test_case(Mqtt311DirectConnectionWithMutualTLS)
    add_net_test_case(Mqtt311DirectConnectionWithHttpProxy)
    add_net_test_case(Mqtt311WSConnectionMinimal)
    add_net_test_case(Mqtt311WSConnectionWithBasicAuth)
    add_net_test_case(Mqtt311WSConnectionWithTLS)
    add_net_test_case(Mqtt311WSConnectionWithHttpProxy)
endif()

#MQTT5 related tests
add_test_case(Mqtt5NewClientMinimal)
add_test_case(Mqtt5NewClientFull)
if(NOT BYO_CRYPTO)
    # MQTT5 TESTS
    add_net_test_case(Mqtt5DirectConnectionMinimal)
    add_net_test_case(Mqtt5DirectConnectionWithBasicAuth)
    add_net_test_case(Mqtt5DirectConnectionWithTLS)
    add_net_test_case(Mqtt5DirectConnectionWithMutualTLS)
    add_net_test_case(Mqtt5DirectConnectionWithHttpProxy)
    add_net_test_case(Mqtt5DirectConnectionFull)
    add_net_test_case(Mqtt5WSConnectionMinimal)
    add_net_test_case(Mqtt5WSConnectionWithBasicAuth)
    add_net_test_case(Mqtt5WSConnectionWithTLS)
    add_net_test_case(Mqtt5WSConnectionWithMutualTLS)
    # Skip the websocket connection with http proxy
    # add_net_test_case(Mqtt5WSConnectionWithHttpProxy)
    add_net_test_case(Mqtt5WSConnectionFull)
    add_net_test_case(Mqtt5InvalidHostname)
    add_net_test_case(Mqtt5InvalidPort)
    add_net_test_case(Mqtt5WSInvalidPort)
    add_net_test_case(Mqtt5SocketTimeout)
    add_net_test_case(Mqtt5IncorrectBasicAuth)
    add_net_test_case(Mqtt5IncorrectWSConnect)
    add_net_test_case(Mqtt5DoubleClientIDFailure)
    add_net_test_case(Mqtt5NegotiatedSettingsHappy)
    add_net_test_case(Mqtt5NegotiatedSettingsFull)
    add_net_test_case(Mqtt5NegotiatedSettingsLimit)
    add_net_test_case(Mqtt5NegotiatedSettingsRejoinAlways)
    add_net_test_case(Mqtt5SubUnsub)
    add_net_test_case(Mqtt5WillTest)
    add_net_test_case(Mqtt5NullPublish)
    add_net_test_case(Mqtt5NullSubscribe)
    add_net_test_case(Mqtt5NullUnsubscribe)
    add_net_test_case(Mqtt5QoS1SubPub)
    add_net_test_case(Mqtt5RetainSetAndClear)

    # IOT CORE TEST
    add_net_test_case(Mqtt5InterruptSub)
    add_net_test_case(Mqtt5InterruptUnsub)
    add_net_test_case(Mqtt5InterruptPublishQoS1)
    add_net_test_case(Mqtt5OperationStatisticsSimple)
    add_net_test_case(Mqtt5SharedSubscriptionTest)

    # Mqtt5-to-3 Adapter
    add_test_case(Mqtt5to3AdapterNewConnectionMin)
    add_test_case(Mqtt5to3AdapterNewClientFull)
    add_net_test_case(Mqtt5to3AdapterDirectConnectionMinimalThroughMqtt3)
    add_net_test_case(Mqtt5to3AdapterWSConnectionMinimalThroughMqtt3)
    add_net_test_case(Mqtt5to3AdapterWithIoTConnectionThroughMqtt3)
    add_net_test_case(Mqtt5to3AdapterDirectConnectionWithMutualTLSThroughMqtt3)
    add_net_test_case(Mqtt5to3AdapterDirectConnectionMinimalThroughMqtt5)
    add_net_test_case(Mqtt5to3AdapterWSConnectionMinimalThroughMqtt5)
    add_net_test_case(Mqtt5to3AdapterWithIoTConnectionThroughMqtt5)
    add_net_test_case(Mqtt5to3AdapterDirectConnectionWithMutualTLSThroughMqtt5)
    add_net_test_case(Mqtt5to3AdapterOperations)
    add_net_test_case(Mqtt5to3AdapterNullPubAck)
    add_net_test_case(Mqtt5to3AdapterMultipleAdapters)
endif()

add_test_case(RuleEngine)

if(AWS_HAS_CI_ENVIRONMENT AND NOT BYO_CRYPTO)
    add_test_case(CognitoCredentialsProviderGetSuccess)
    add_test_case(STSCredentialsProviderGetSuccess)

    if(ENABLE_PROXY_INTEGRATION_TESTS)
        add_test_case(CognitoCredentialsProviderGetSuccessProxy)
        add_test_case(STSCredentialsProviderGetSuccessProxy)
    endif()
endif()

generate_cpp_test_driver(${TEST_BINARY_NAME})

aws_add_sanitizers(${TEST_BINARY_NAME})

 # set extra warning flags
if(AWS_WARNINGS_ARE_ERRORS)
    if(MSVC)
        target_compile_options(${TEST_BINARY_NAME} PRIVATE /W4 /WX /wd4068)
    else()
        target_compile_options(${TEST_BINARY_NAME} PRIVATE -Wall -Wno-long-long -Werror)
    endif()
endif()

add_custom_command(TARGET ${TEST_BINARY_NAME} PRE_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_directory
    ${CMAKE_CURRENT_SOURCE_DIR}/resources $<TARGET_FILE_DIR:${TEST_BINARY_NAME}>)

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=aws-crt-cpp
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.26.2
pkgrel=1
pkgdesc='C++ wrapper around the aws-c-* libraries. Provides Cross-Platform Transport Protocols and SSL/TLS implementations for C++ (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/awslabs/aws-crt-cpp'
msys2_references=(
  'archlinux: aws-crt-cpp'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-aws-c-common"
         "${MINGW_PACKAGE_PREFIX}-aws-c-http"
         "${MINGW_PACKAGE_PREFIX}-aws-c-mqtt"
         "${MINGW_PACKAGE_PREFIX}-aws-c-auth"
         "${MINGW_PACKAGE_PREFIX}-aws-c-s3"
         "${MINGW_PACKAGE_PREFIX}-aws-c-event-stream")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/awslabs/aws-crt-cpp/archive/refs/tags/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('f7c9a131abde8b802addcf1e7b0d38a95fd9ad83bc1c81d7b47a6ce285df70e0')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  find . -name "CMakeLists.txt" -exec sed "s/aws_add_sanitizers/#aws_add_sanitizers/g" -i {} \;
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_PREFIX_PATH=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DAWS_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_SHARED_LIBS=OFF \
      -DBUILD_DEPS=OFF \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_PREFIX_PATH=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DAWS_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_DEPS=OFF \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"

  cd "${srcdir}/build-${MSYSTEM}-shared"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  PATH=$PWD:$PATH ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"
}

package() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
